﻿@using LAP.DomainModels.Entities.Adviser
@model ActivityEvent
<div class="modal-dialog modal-lg modal-dialog-scrollable" role="document">
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">@(Model?.Id > 0 ? "Edit" : "Add") @ActivityTypeEnum.Event.GetDisplayName()</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <i aria-hidden="true" class="ki ki-close"></i>
            </button>
        </div>
        <div class="modal-body">
            <form action="adviser/dashboard/saveevent" class="form fv-plugins-bootstrap fv-plugins-framework" id="AddEvent_form" method="post" data-ajax="true" data-ajax-begin="onFormBegin" data-ajax-complete="SaveEventComplete">
                <input type="hidden" asp-for="Id" />
                <input type="hidden" asp-for="Guid" />
                <input type="hidden" name="confirmed" id="confirmed" />
                <input type="hidden" id="btnSubmitId" value="btn_submit_activity" />
                <div class="row">
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="Type"></label>
                            <select class="form-control form-control-lg" asp-for="Type" asp-items="Html.GetEnumSelectList<EventTypeEnum>()" data-size="6">
                            </select>
                            <span asp-validation-for="Type" class="text-danger"></span>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="Title"></label>
                            <input asp-for="Title" class="form-control form-control-lg capitalize">
                            <span asp-validation-for="Title" class="text-danger"></span>
                        </div>
                    </div>
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="Date"></label>
                            <div class="input-group date datepicker-control" id="AppointmentDate">
                                <input type="text" asp-for="Date" asp-format="{0:MM'/'dd'/'yyyy}" class="form-control form-control-lg datemask">
                                <div class="input-group-append">
                                    <span class="input-group-text">
                                        <i class="far fa-calendar-alt"></i>
                                    </span>
                                </div>
                            </div>
                            <span asp-validation-for="Date" class="text-danger"></span>
                        </div>
                    </div>
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="Tag"></label>
                            <input asp-for="Tag" class="form-control form-control-lg">
                            <span asp-validation-for="Tag" class="text-danger"></span>
                        </div>
                    </div>
                </div>
                <div id="PrePostInfo-container">
                    <hr />
                    <h4 class="text-primary">Pre-Event Info</h4>
                    <div class="row">
                        <div class="col-xl-4">
                            <div class="form-group">
                                <label asp-for="EstimatedCost"></label>
                                <input asp-for="EstimatedCost" class="form-control form-control-lg currency" type="text">
                                <span asp-validation-for="EstimatedCost" class="text-danger"></span>
                            </div>
                        </div>
                        <div class="col-xl-4">
                            <div class="form-group">
                                <label asp-for="EstimatedAtendees"></label>
                                <input asp-for="EstimatedAtendees" class="form-control form-control-lg numericOnly" type="text" maxlength="6">
                                <span asp-validation-for="EstimatedAtendees" class="text-danger"></span>
                            </div>
                        </div>
                        <div class="col-xl-4">
                            <div class="form-group">
                                <label asp-for="EstimatedLeads"></label>
                                <input asp-for="EstimatedLeads" class="form-control form-control-lg numericOnly" type="text" maxlength="6">
                                <span asp-validation-for="EstimatedLeads" class="text-danger"></span>
                            </div>
                        </div>
                    </div>
                    <hr />
                    <h4 class="text-primary">Post-Event Info</h4>
                    <div class="row">
                        <div class="col-xl-4">
                            <div class="form-group">
                                <label asp-for="ActualCost"></label>
                                <input asp-for="ActualCost" class="form-control form-control-lg currency" type="text">
                                <span asp-validation-for="ActualCost" class="text-danger"></span>
                            </div>
                        </div>
                        <div class="col-xl-4">
                            <div class="form-group">
                                <label asp-for="ActualNoOfAttendees"></label>
                                <input asp-for="ActualNoOfAttendees" class="form-control form-control-lg numericOnly" type="text" maxlength="6">
                                <span asp-validation-for="ActualNoOfAttendees" class="text-danger"></span>
                            </div>
                        </div>
                        <div class="col-xl-4">
                            <div class="form-group">
                                <label># Of Leads Generated</label>
                                <input id="ActualNoOfLead" class="form-control form-control-lg numericOnly" readonly type="text" maxlength="2" value="@(Model!= null? Model.Leads.Count() :0)">
                            </div>
                        </div>
                    </div>
                </div>
                <div id="lead-container">
                    <hr />
                    <div class="d-flex justify-content-between">
                        <div class="flex-grow-1">
                            <h4 class="text-primary">Lead Details</h4>
                        </div>
                        <div class="align-self-center">
                            <button class="btn btn-sm btn-warning font-weight-bold btn-lead-add" type="button"><i class="fas fa-plus"></i>New Lead</button>
                        </div>
                    </div>
                    <table class="table table-sm table-borderless mt-3" style="font-size:14px;" id="lead-table">
                        <tr>
                            <td></td>
                            <td width="25%">First Name</td>
                            <td width="25%">Last Name</td>
                            <td>Email</td>
                            <td width="60px"></td>
                        </tr>
                        @if (Model != null && Model.Leads.Any())
                        {
                            @foreach (var item in Model.Leads.Select((value, i) => new { i, value }))
                            {
                                <tr>
                                    <td class="align-top">
                                        <span class="css-counter"></span>
                                        <input type="hidden" value="@item.value.Id" name="leads[@item.i].Id" id="leads[@item.i].Id" />
                                        <input type="hidden" value="@item.value.Guid" name="leads[@item.i].Guid" id="leads[@item.i].Guid" class="guid" />
                                        <input type="hidden" value="@(item.value.Active ? "true": "false")" name="leads[@item.i].Active" id="leads[@item.i].Active" />
                                    </td>
                                    <td>
                                        <input value="@item.value.FirstName" type="text" class="form-control form-control-sm capitalize required" readonly name="leads[@item.i].FirstName" id="leads[@item.i].FirstName" data-field="First Name" />
                                        <span class="text-danger" data-valmsg-for="leads[@item.i].FirstName" data-valmsg-replace="true"></span>
                                    </td>
                                    <td>
                                        <input value="@item.value.LastName" type="text" class="form-control form-control-sm capitalize required" readonly name="leads[@item.i].LastName" id="leads[@item.i].LastName" data-field="Last Name" />
                                        <span class="text-danger" data-valmsg-for="leads[@item.i].LastName" data-valmsg-replace="true"></span>
                                    </td>
                                    <td>
                                        <input value="@item.value.Email" data-guid="@item.value.Guid" type="text" class="form-control form-control-sm tolowercase required email" readonly name="leads[@item.i].Email" id="leads[@item.i].Email" data-field="Email" maxlength="50" />
                                        <span class="text-danger" data-valmsg-for="leads[@item.i].Email" data-valmsg-replace="true"></span>
                                    </td>
                                    <td>
                                        <div class="display-view">
                                            <button class="btn btn-icon btn-xs btn-lead-edit @(!item.value.Active ? "disabled-div is-lead" :"")" type="button" data-toggle="tooltip" data-html="true" data-original-title="@(!item.value.Active ? "You cannot edit this lead <br /> as invitation is already sent" :"Edit")">
                                                <i class="la la-pencil-alt icon-xl text-primary"></i>
                                            </button>
                                            <button class="btn btn-icon btn-xs btn-lead-delete @(!item.value.Active ? "disabled-div is-lead" :"")" type="button" data-toggle="tooltip" data-html="true" data-original-title="@(!item.value.Active ? "You cannot delete this lead <br /> as invitation is already sent" :"Delete")">
                                                <i class="la la-trash icon-xl text-danger"></i>
                                            </button>
                                        </div>
                                        <div class="edit-view d-none">
                                            <button class="btn btn-icon btn-xs btn-lead-save" type="button" data-toggle="tooltip" data-original-title="Save">
                                                <i class="la la-save icon-xl text-primary"></i>
                                            </button>
                                            <button class="btn btn-icon btn-xs btn-lead-cancel" type="button" data-toggle="tooltip" data-original-title="Cancel">
                                                <i class="la la-remove icon-xl text-danger"></i>
                                            </button>
                                        </div>
                                    </td>
                                </tr>
                            }
                        }
                    </table>
                </div>
            </form>
        </div>
        <div class="modal-footer">
            <button class="btn btn-primary font-weight-bold" id="btn_submit_activity" onclick='$("#AddEvent_form").submit()'>
                <i class="la la-save"></i> Save
            </button>
        </div>
    </div>
</div>
<style>
    body {
        counter-reset: section;
    }

    .css-counter::before {
        counter-increment: section;
        content: counter(section)".";
    }
</style>
<script>
    $.validator.addMethod("exist", function (value, element, params) {
        return this.optional(element) || params.filter(x => x === value).length < 2;
    }, "Email Address already exists");
    setTimeout(function () { validateLeads(); }, 0);
    var showHidePrePostInfo = function () {
        var type = $("#Type").val();
        $("#PrePostInfo-container").removeClass("d-none");
        if (type == EventTypeEnum.NonClientAdvocate) {
            $("#PrePostInfo-container").addClass("d-none");
            $("#PrePostInfo-container input:not(#ActualNoOfLead)").val("");
        }
    }
    showHidePrePostInfo();
    $("#Type").change(function (e) {
        showHidePrePostInfo();
    });
    $('.btn-lead-add').click(function (e) {
        if ($("#AddEvent_form").valid()) {
            $("#lead-table input[type='text']").prop("readonly", true);
            $("#lead-table .edit-view").addClass("d-none");
            $("#lead-table .display-view").removeClass("d-none");
            var rowCount = $("#lead-table").find('tr').length - 1;
            var item = { index: rowCount };
            $("#lead-table").append($("#lead-template").tmpl(item));
            validateLeads();
            $("#ActualNoOfLead").val(item.index + 1);
        }
    });
</script>